searchNodes=[{"type":"module","title":"Membrane.AudioMixer","doc":"This element performs audio mixing. Audio format can be set as an element option or received through stream_format from input pads. All received stream_format have to be identical and match ones in element option (if that option is different from nil ). Input pads can have offset - it tells how much silence should be added before first sample from that pad. Offset has to be positive. Mixer mixes only raw audio (PCM), so some parser may be needed to precede it in pipeline. Element options Passed via struct Membrane.AudioMixer.t/0 stream_format RawAudio . t ( ) Default value: nil The value defines a raw audio format of pads connected to the element. It should be the same for all the pads. frames_per_buffer pos_integer ( ) Default value: 2048 Assumed number of raw audio frames in each buffer. Used when converting demand from buffers into bytes. prevent_clipping boolean ( ) Default value: true Defines how the mixer should act in the case when an overflow happens. If true, the wave will be scaled down, so a peak will become the maximal value of the sample in the format. See Membrane.AudioMixer.ClipPreventingAdder . If false, overflow will be clipped to the maximal value of the sample in the format. See Membrane.AudioMixer.Adder . native_mixer boolean ( ) Default value: false The value determines if mixer should use NIFs for mixing audio. Only clip preventing version of native mixer is available. See Membrane.AudioMixer.NativeAdder . synchronize_buffers? boolean ( ) Default value: false The value determines if mixer should synchronize buffers based on pts values. If true, mixer will synchronize buffers based on its pts values. If buffer pts value is lower then the current mixing time (last_ts_sent) it will be dropped. If false, mixer will take all incoming buffers no matter what pts they have and put it in the queue. Pads :input Accepted formats: % RawAudio { sample_format : sample_format } when sample_format in [ :s8 , :s16le , :s16be , :s24le , :s24be , :s32le , :s32be ] RemoteStream Direction: :input Availability: :on_request Flow control: :manual Demand unit: :bytes Pad options: offset Time . non_neg ( ) Default value: 0 Offset of the input audio at the pad. :output Accepted formats: RawAudio Direction: :output Availability: :always Flow control: :manual Demand unit: nil","ref":"Membrane.AudioMixer.html"},{"type":"function","title":"Membrane.AudioMixer.options/0","doc":"Returns description of options available for this module","ref":"Membrane.AudioMixer.html#options/0"},{"type":"type","title":"Membrane.AudioMixer.input_pad_opts/0","doc":"Options for pad :input","ref":"Membrane.AudioMixer.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.AudioMixer.t/0","doc":"Struct containing options for Membrane.AudioMixer","ref":"Membrane.AudioMixer.html#t:t/0"},{"type":"module","title":"Membrane.AudioMixerBin","doc":"Bin element distributing a mixing job between multiple Membrane.AudioMixer elements. A tree of AudioMixers is created according to max_inputs_per_node parameter: if number of input tracks is smaller than max_inputs_per_node , only one AudioMixer element is created for the entire job if there are more input tracks than max_inputs_per_node , there are created enough mixers so that each mixer has at most max_inputs_per_node inputs - outputs from those mixers are then mixed again following the same rules - another level of mixers is created having enough mixers so that each mixer on this level has at most max_inputs_per_node inputs (those are now the outputs of the previous level mixers). Levels are created until only one mixer in the level is needed - output from this mixer is the final mixed track. Bin allows for specifying options for Membrane.AudioMixer , which are applied for all AudioMixers. Recommended to use in case of mixing jobs with many inputs. A number of inputs to the bin must be specified in the number_of_inputs option. Bin options Passed via struct Membrane.AudioMixerBin.t/0 max_inputs_per_node pos_integer ( ) Default value: 10 The maximum number of inputs to a single mixer in the mixers tree. Must be at least 2. mixer_options AudioMixer . t ( ) Default value: %Membrane.AudioMixer{stream_format: nil, frames_per_buffer: 2048, prevent_clipping: true, native_mixer: false, synchronize_buffers?: false} The options that would be passed to each created AudioMixer. number_of_inputs pos_integer ( ) Required The exact number of inputs to the bin. Must be at least 1. Pads :input Accepted formats: % RawAudio { sample_format : sample_format } when sample_format in [ :s8 , :s16le , :s16be , :s24le , :s24be , :s32le , :s32be ] Membrane.RemoteStream Direction: :input Availability: :on_request Pad options: offset Time . t ( ) Default value: 0 Offset of the input audio at the pad. :output Accepted formats: RawAudio Direction: :output Availability: :always","ref":"Membrane.AudioMixerBin.html"},{"type":"function","title":"Membrane.AudioMixerBin.gen_mixing_spec/3","doc":"Generates a spec for a single mixer or a tree of mixers. Levels of the tree will be 0-indexed with tree root being level 0 For a bottom level of mixing tree (leaves of the tree) links generator will be used to generate links between inputs and mixers.","ref":"Membrane.AudioMixerBin.html#gen_mixing_spec/3"},{"type":"function","title":"Membrane.AudioMixerBin.options/0","doc":"Returns description of options available for this module","ref":"Membrane.AudioMixerBin.html#options/0"},{"type":"type","title":"Membrane.AudioMixerBin.input_pad_opts/0","doc":"Options for pad :input","ref":"Membrane.AudioMixerBin.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.AudioMixerBin.t/0","doc":"Struct containing options for Membrane.AudioMixerBin","ref":"Membrane.AudioMixerBin.html#t:t/0"},{"type":"module","title":"Membrane.LiveAudioMixer","doc":"This element performs audio mixing for live streams. Live Audio Mixer starts to mix audio after the first input pad is added or, if latency option is set to nil , when start_mixing notification is send. From this point, the mixer will produce an audio until :schedule_eos notification and :end_of_stream are received on all input pads. Mixer mixes only raw audio (PCM), so some parser may be needed to precede it in pipeline. Notifications :schedule_eos - mixer will send end_of_stream when it processes all input streams. After sending :schedule_eos mixer will raise if it gets a new input pad. { :start_mixing , latency} - mixer will start mixing audio after latency (non_neg_integer()). Audio that will come before the notification will be buffered. Input pads can have offset - it tells how much timestamps differ from mixer time. Element options Passed via struct Membrane.LiveAudioMixer.t/0 prevent_clipping boolean ( ) Default value: false Defines how the mixer should act in the case when an overflow happens. If true, the wave will be scaled down, so a peak will become the maximal value of the sample in the format. See Membrane.AudioMixer.ClipPreventingAdder . If false, overflow will be clipped to the maximal value of the sample in the format. See Membrane.AudioMixer.Adder . native_mixer boolean ( ) Default value: false The value determines if mixer should use NIFs for mixing audio. Only clip preventing version of native mixer is available. See Membrane.AudioMixer.NativeAdder . latency non_neg_integer ( ) | nil Default value: 200 |&gt; Membrane.Time.milliseconds() The value determines after what time the clock will start interval that mixes audio in real time. Latency is crucial to quality of output audio, the smaller the value, the more packets will be lost. But the bigger the value, the bigger the latency of stream. Audio Mixer allows starting mixing earlier with parent_notification :start_mixing . In this case, stream_format has to be passed through options. If notification :start_mixing is sent after mixing has started, the message will be discarded Start mixing manually: set latency to nil mixing has to be started manually by sending :start_mixing notification. stream_format RawAudio . t ( ) | nil Default value: nil The value defines a raw audio format of pads connected to the element. It should be the same for all the pads. It is necessary if latency is set to nil. Pads :input Accepted formats: % RawAudio { sample_format : sample_format } when sample_format in [ :s8 , :s16le , :s16be , :s24le , :s24be , :s32le , :s32be ] Direction: :input Availability: :on_request Flow control: :auto Pad options: offset Time . non_neg ( ) Default value: 0 Offset of the input audio at the pad. :output Accepted formats: RawAudio Direction: :output Availability: :always Flow control: :auto","ref":"Membrane.LiveAudioMixer.html"},{"type":"function","title":"Membrane.LiveAudioMixer.options/0","doc":"Returns description of options available for this module","ref":"Membrane.LiveAudioMixer.html#options/0"},{"type":"type","title":"Membrane.LiveAudioMixer.input_pad_opts/0","doc":"Options for pad :input","ref":"Membrane.LiveAudioMixer.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.LiveAudioMixer.t/0","doc":"Struct containing options for Membrane.LiveAudioMixer","ref":"Membrane.LiveAudioMixer.html#t:t/0"},{"type":"module","title":"Membrane.AudioMixer.Adder","doc":"Module responsible for mixing audio tracks (all in the same format, with the same number of channels and sample rate). The result is a single track in the format mixed tracks are encoded in. If overflow happens during mixing, it is being clipped to the max value of sample in this format.","ref":"Membrane.AudioMixer.Adder.html"},{"type":"type","title":"Membrane.AudioMixer.Adder.t/0","doc":"","ref":"Membrane.AudioMixer.Adder.html#t:t/0"},{"type":"module","title":"Membrane.AudioMixer.ClipPreventingAdder","doc":"Module responsible for mixing audio tracks (all in the same format, with the same number of channels and sample rate). The result is a single track in the format mixed tracks are encoded in. If overflow happens during mixing, a wave will be scaled down to the max sample value. Description of the algorithm: Start with an empty queue Enqueue merged values while the sign of the values remains the same If the sign of values changes or adder is flushed: If none of the values overflows limits of the format, convert the queued values to binary samples and return them Otherwise, scale down the queued values, so the peak of the wave will become maximal (minimal) allowed value, then convert it to binary samples and return them.","ref":"Membrane.AudioMixer.ClipPreventingAdder.html"},{"type":"type","title":"Membrane.AudioMixer.ClipPreventingAdder.t/0","doc":"","ref":"Membrane.AudioMixer.ClipPreventingAdder.html#t:t/0"},{"type":"module","title":"Membrane.AudioMixer.NativeAdder","doc":"Module responsible for mixing audio tracks (all in the same format, with the same number of channels and sample rate). The result is a single track in the format mixed tracks are encoded in. If overflow happens during mixing, a wave will be scaled down to the max sample value. Uses NIFs for mixing. Description of the algorithm: Start with an empty queue Enqueue merged values while the sign of the values remains the same If the sign of values changes or adder is flushed: If none of the values overflows limits of the format, convert the queued values to binary samples and return them Otherwise, scale down the queued values, so the peak of the wave will become maximal (minimal) allowed value, then convert it to binary samples and return them.","ref":"Membrane.AudioMixer.NativeAdder.html"},{"type":"module","title":"Membrane.LiveAudioMixer.LiveQueue","doc":"There are a lot of problems that the mixer can encounter while processing live audio streams: packet loss resulting in small stream discontinuity connection issues resulting in complete lack of data the need for enforcing max latency on the stream - packets that come too late have to be dropped The LiveQueue tackles all those problems. It has an independent queue for each stream. Every gap caused by late or dropped packets are filled with silence. If there is a need for more audio than there is in a queue, the missing part will also be filled with silence.","ref":"Membrane.LiveAudioMixer.LiveQueue.html"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.add_buffer/3","doc":"Adds to a specific queue. When a buffer is too old it will be dropped When a part of a buffer is too old, only the part that is &quot;fresh&quot; will be added. When a whole buffer is &quot;fresh&quot;, the whole buffer will be added. All the wholes between audio packets will be filled with silence. The state of the buffer, whether it's too old or not, is based on LiveQueue's current_time .","ref":"Membrane.LiveAudioMixer.LiveQueue.html#add_buffer/3"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.add_queue/3","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.html#add_queue/3"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.all_queues_empty?/1","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.html#all_queues_empty?/1"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.get_audio/2","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.html#get_audio/2"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.init/1","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.html#init/1"},{"type":"function","title":"Membrane.LiveAudioMixer.LiveQueue.remove_queue/2","doc":"Removes queue from a live queue. If the queue is empty, it will be removed right away. Otherwise, it will be marked as draining and will be removed when it will get empty.","ref":"Membrane.LiveAudioMixer.LiveQueue.html#remove_queue/2"},{"type":"opaque","title":"Membrane.LiveAudioMixer.LiveQueue.t/0","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.html#t:t/0"},{"type":"module","title":"Membrane.LiveAudioMixer.LiveQueue.Queue","doc":"The Queue module is responsible for storing a single live audio stream.","ref":"Membrane.LiveAudioMixer.LiveQueue.Queue.html"},{"type":"type","title":"Membrane.LiveAudioMixer.LiveQueue.Queue.t/0","doc":"","ref":"Membrane.LiveAudioMixer.LiveQueue.Queue.html#t:t/0"},{"type":"module","title":"Membrane.AudioInterleaver","doc":"Element responsible for interleaving several mono audio streams into single interleaved stream. All input streams should be in the same raw audio format, defined by input_stream_format option. Channels are interleaved in order given in order option - currently required, no default available. Each input pad should be identified with your custom id (using via_in(Pad.ref(:input, your_example_id) ) Element options Passed via struct Membrane.AudioInterleaver.t/0 input_stream_format RawAudio . t ( ) Default value: nil The value defines a raw audio format of pads connected to the element. It should be the same for all the pads. frames_per_buffer pos_integer ( ) Default value: 2048 Assumed number of raw audio frames in each buffer. Used when converting demand from buffers into bytes. order [ any ( ) ] Required Order in which channels should be interleaved Pads :input Accepted formats: % RawAudio { channels : 1 } Membrane.RemoteStream Direction: :input Availability: :on_request Flow control: :manual Demand unit: :bytes Pad options: offset Time . t ( ) Default value: 0 Offset of the input audio at the pad. :output Accepted formats: RawAudio Direction: :output Availability: :always Flow control: :manual Demand unit: nil","ref":"Membrane.AudioInterleaver.html"},{"type":"function","title":"Membrane.AudioInterleaver.options/0","doc":"Returns description of options available for this module","ref":"Membrane.AudioInterleaver.html#options/0"},{"type":"type","title":"Membrane.AudioInterleaver.input_pad_opts/0","doc":"Options for pad :input","ref":"Membrane.AudioInterleaver.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.AudioInterleaver.t/0","doc":"Struct containing options for Membrane.AudioInterleaver","ref":"Membrane.AudioInterleaver.html#t:t/0"},{"type":"module","title":"Membrane.AudioInterleaver.DoInterleave","doc":"Module responsible for interleaving audio tracks (all in the same format, with 1 channel) in a given order.","ref":"Membrane.AudioInterleaver.DoInterleave.html"},{"type":"function","title":"Membrane.AudioInterleaver.DoInterleave.interleave/4","doc":"Order queues according to order , take bytes_per_channel from each queue (all queues must be at least bytes_per_channel long), and interleave them.","ref":"Membrane.AudioInterleaver.DoInterleave.html#interleave/4"},{"type":"extras","title":"Membrane Audio Mix Plugin","doc":"Plugin providing elements for mixing and interleaving raw audio frames. It is a part of Membrane Multimedia Framework .","ref":"readme.html"},{"type":"extras","title":"Membrane Audio Mix Plugin - Installation","doc":"First, you need to install MAD on your system. macOS brew install mad Ubuntu sudo apt-get install libmad0-dev Then, add the following line to your deps in mix.exs : { :membrane_audio_mix_plugin , &quot;~&gt; 0.16.1&quot; } and run mix deps.get .","ref":"readme.html#installation"},{"type":"extras","title":"Membrane Audio Mix Plugin - Description","doc":"Elements operate only on raw audio (PCM), so some parser may be needed to precede them in a pipeline. The elements expect to receive the same audio stream format on each input pad. Audio Mixers' input pads can have offset - in the case of a regular mixer it tells how much silence should be added before the first sample. The live mixer will rewrite timestamps based on the value. Offset has to be positive. Mixing and interleaving are tested only for integer audio formats. Mixer The Mixer adds samples from all pads. It has two strategies to deal with the overflow: scaling down waves and clipping. Stream format can be additionally enforced by setting an element option ( :stream_format ) Interleaver This element joins several mono audio streams (with one channel) into one stream with interleaved channels. If audio streams have different durations, all shorter streams are appended with silence to match the longest stream. Each channel must be named by providing an input pad name and the channel layout using those names must be provided (see usage example ). All inputs have to be added before starting the pipeline and should not be changed during interleaver's work. Stream format can be additionally enforced by setting an element option ( :stream_format ) Live Mixer The Live Mixer adds samples from all pads. It has two strategies to deal with the overflow: scaling down waves and clipping. The Live Mixer will produce audio in real time meaning every interval there will be sent a buffer of fixed duration. In situations where an audio packet is late or doesn't come, the mixer will fill the gaps with silence","ref":"readme.html#description"},{"type":"extras","title":"Membrane Audio Mix Plugin - Usage Example","doc":"AudioMixer defmodule Mixing.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ctx , _options ) do structure = [ child ( { :file_src , 1 } , % Membrane.File.Source { location : &quot;/tmp/input_1.raw&quot; } ) |&gt; get_child ( :mixer ) , child ( { :file_src , 2 } , % Membrane.File.Source { location : &quot;/tmp/input_2.raw&quot; } ) |&gt; via_in ( :input , options : [ offset : Membrane.Time . milliseconds ( 5000 ) ] ) |&gt; get_child ( :mixer ) , child ( :mixer , % Membrane.AudioMixer { stream_format : % Membrane.RawAudio { channels : 1 , sample_rate : 16_000 , sample_format : :s16le } } ) |&gt; child ( :converter , % Membrane.FFmpeg.SWResample.Converter { input_stream_format : % Membrane.RawAudio { channels : 1 , sample_rate : 16_000 , sample_format : :s16le } , output_stream_format : % Membrane.RawAudio { channels : 2 , sample_rate : 48_000 , sample_format : :s16le } } ) |&gt; child ( :player , Membrane.PortAudio.Sink ) ] { [ spec : structure ] , %{ } } end end AudioInterleaver defmodule Interleave.Pipeline do use Membrane.Pipeline alias Membrane.File . { Sink , Source } @impl true def handle_init ( _ctx , { path_to_wav_1 , path_to_wav_2 } ) do structure = [ child ( { :file , 1 } , % Source { location : path_to_wav_1 } ) |&gt; child ( { :parser , 1 } , Membrane.WAV.Parser ) |&gt; get_child ( :interleaver ) , child ( { :file , 2 } , % Source { location : path_to_wav_2 } ) |&gt; child ( { :parser , 2 } , Membrane.WAV.Parser ) |&gt; get_child ( :interleaver ) , child ( :interleaver , % Membrane.AudioInterleaver { input_stream_format : % Membrane.RawAudio { channels : 1 , sample_rate : 16_000 , sample_format : :s16le } , order : [ :left , :right ] } ) |&gt; child ( :file_sink , % Sink { location : &quot;output.raw&quot; } ) ] { [ spec : structure ] , %{ } } end end","ref":"readme.html#usage-example"},{"type":"extras","title":"Membrane Audio Mix Plugin - Copyright and License","doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]